import paho.mqtt.client as mqtt
import os
import time

#tento program odbavuje, separátně od hlavního programu, vypnutí a restar systému, samostatně spouštění program
host = "localhost"
port = 1883

shutdown_topic = "MIXANM/PowerOff"
shutdown_off_value = "OFF"
shutdown_on_value = "ON"

reboot_topic = "MIXANM/Reboot"
reboot_off_value = "OFF"
reboot_on_value = "ON"

def Shutdown():
    try:
        print("Shutdown...")
        os.system("sudo -S shutdown now")
    except:
        print("Error in shutdown...")
    
def Reboot():
    try:
        print("Reboot...")
        os.system("sudo -S reboot now")
    except:
        print("Error in reboot...")
    
def on_connect(client, userdata, flags, rc):
    try:
        client.subscribe("MIXANM/#", 0)
    except:
        pass

def on_message(client, userdata, msg):
    try:
        function(msg.topic, msg.payload.decode("utf_8"))
    except:
        pass

def function(topic: str, value):
    try:
        if (topic == shutdown_topic) & (value == shutdown_on_value):
            Shutdown()
        elif (topic == reboot_topic) & (value == reboot_on_value):
            Reboot()
    except:
        pass

if __name__ == "__main__":
    try:
        client = mqtt.Client()
        client.on_connect = on_connect
        client.on_message = on_message
        client.connect(host, port)
        client.publish(shutdown_topic,shutdown_off_value)
        client.publish(reboot_topic,reboot_off_value)
        client.loop_start()
        while True:
            time.sleep(1)
    except:
        pass   