import smbus
#metoda pro zjištění počet zařízení na sběrnici i2c a jejich adres
def slave_counter_i2c(bus):
    bus = smbus.SMBus(bus) # 1 indicates /dev/i2c-n (0 or 1)
    i2c_slave_count = 0
    i2c_slave_address = []
    for device in range(128):
        try:
            bus.read_byte(device)
            i2c_slave_count += 1
            i2c_slave_address.append(device)
        except: # exception if read_byte fails
            pass
    return {"count": i2c_slave_count,"address": i2c_slave_address}